package provide DS9 1.0

######
# Begin autogenerated taccle (version 1.3) routines.
# Although taccle itself is protected by the GNU Public License (GPL)
# all user-supplied functions are protected by their respective
# author's license.  See http://mini.net/tcl/taccle for other details.
######

namespace eval binsend {
    variable yylval {}
    variable table
    variable rules
    variable token {}
    variable yycnt 0
    variable yyerr 0
    variable save_state 0

    namespace export yylex
}

proc binsend::YYABORT {} {
    return -code return 1
}

proc binsend::YYACCEPT {} {
    return -code return 0
}

proc binsend::YYERROR {} {
    variable yyerr
    set yyerr 1
}

proc binsend::yyclearin {} {
    variable token
    variable yycnt
    set token {}
    incr yycnt -1
}

proc binsend::yyerror {s} {
    puts stderr $s
}

proc binsend::setupvalues {stack pointer numsyms} {
    upvar 1 1 y
    set y {}
    for {set i 1} {$i <= $numsyms} {incr i} {
        upvar 1 $i y
        set y [lindex $stack $pointer]
        incr pointer
    }
}

proc binsend::unsetupvalues {numsyms} {
    for {set i 1} {$i <= $numsyms} {incr i} {
        upvar 1 $i y
        unset y
    }
}

array set binsend::table {
  6:0 reduce
  3:0,target 4
  0:257 shift
  7:0 reduce
  0:264,target 8
  0:258 shift
  8:0 reduce
  5:0,target 5
  0:260 shift
  0:259 shift
  9:0 accept
  0:261 shift
  7:0,target 8
  0:262 shift
  0:258,target 2
  0:263 shift
  9:0,target 0
  0:261,target 5
  0:264 shift
  2:0,target 3
  0:265 goto
  0:263,target 7
  4:0,target 6
  0:265,target 9
  6:0,target 7
  1:0 reduce
  0:257,target 1
  2:0 reduce
  8:0,target 1
  3:0 reduce
  0:260,target 4
  0:259,target 3
  4:0 reduce
  1:0,target 2
  5:0 reduce
  0:262,target 6
}

array set binsend::rules {
  2,l 265
  6,l 265
  3,l 265
  7,l 265
  0,l 266
  4,l 265
  8,l 265
  1,l 265
  5,l 265
}

array set binsend::rules {
  5,dc 1
  0,dc 1
  8,dc 1
  3,dc 1
  6,dc 1
  1,dc 1
  4,dc 1
  7,dc 1
  2,dc 1
}

array set binsend::rules {
  7,line 26
  4,line 23
  1,line 20
  6,line 25
  3,line 22
  8,line 27
  5,line 24
  2,line 21
}

array set binsend::lr1_table {
  0 {{0 0 0} {1 0 0} {2 0 0} {3 0 0} {4 0 0} {5 0 0} {6 0 0} {7 0 0} {8 0 0}}
  1 {{2 0 1}}
  2 {{3 0 1}}
  3 {{4 0 1}}
  4 {{6 0 1}}
  0,trans {{257 1} {258 2} {259 3} {260 4} {261 5} {262 6} {263 7} {264 8} {265 9}}
  5 {{5 0 1}}
  1,trans {}
  2,trans {}
  6 {{7 0 1}}
  3,trans {}
  7 {{8 0 1}}
  4,trans {}
  8 {{1 0 1}}
  5,trans {}
  9 {{0 0 1}}
  6,trans {}
  7,trans {}
  8,trans {}
  9,trans {}
}

array set binsend::token_id_table {
  0,t 0
  0 {$}
  264,line 15
  262,title FILTER
  263,title FUNCTION
  266,line 28
  error,t 0
  error error
  264,title LOCK
  265,title {}
  258,line 9
  266,title {}
  261,line 12
  error,line 18
  257 ABOUT_
  257,t 0
  263,line 14
  258 BUFFERSIZE_
  258,t 0
  error,title {}
  260,t 0
  260 DEPTH_
  259 COLS_
  259,t 0
  265,line 19
  261,t 0
  261 FACTOR_
  262,t 0
  262 FILTER_
  257,line 8
  263,t 0
  263 FUNCTION_
  264,t 0
  264 LOCK_
  260,line 11
  257,title ABOUT
  259,line 10
  265,t 1
  265 binsend
  258,title BUFFERSIZE
  266,t 1
  266 start'
  262,line 13
  260,title DEPTH
  259,title COLS
  261,title FACTOR
}

proc binsend::yyparse {} {
    variable yylval
    variable table
    variable rules
    variable token
    variable yycnt
    variable lr1_table
    variable token_id_table
    variable yyerr
    variable save_state

    set yycnt 0
    set state_stack {0}
    set value_stack {{}}
    set token ""
    set accepted 0
    set yyerr 0
    set save_state 0

    while {$accepted == 0} {
        set state [lindex $state_stack end]
        if {$token == ""} {
            set yylval ""
            set token [yylex]
            set buflval $yylval
	    if {$token>0} {
	        incr yycnt
            }
        }
        if {![info exists table($state:$token)] || $yyerr} {
	    if {!$yyerr} {
	        set save_state $state
	    }
            # pop off states until error token accepted
            while {[llength $state_stack] > 0 && \
                       ![info exists table($state:error)]} {
                set state_stack [lrange $state_stack 0 end-1]
                set value_stack [lrange $value_stack 0 \
                                       [expr {[llength $state_stack] - 1}]]
                set state [lindex $state_stack end]
            }
            if {[llength $state_stack] == 0} {
 
	        set rr { }
                if {[info exists lr1_table($save_state,trans)] && [llength $lr1_table($save_state,trans)] >= 1} {
                    foreach trans $lr1_table($save_state,trans) {
                        foreach {tok_id nextstate} $trans {
			    set ss $token_id_table($tok_id,title)
			    if {$ss != {}} {
			        append rr "$ss, "
                            }
                        }
                    }
                }
		set rr [string trimleft $rr { }]
		set rr [string trimright $rr {, }]
                yyerror "parse error, expecting: $rr"


                return 1
            }
            lappend state_stack [set state $table($state:error,target)]
            lappend value_stack {}
            # consume tokens until it finds an acceptable one
            while {![info exists table($state:$token)]} {
                if {$token == 0} {
                    yyerror "end of file while recovering from error"
                    return 1
                }
                set yylval {}
                set token [yylex]
                set buflval $yylval
            }
            continue
        }
        switch -- $table($state:$token) {
            shift {
                lappend state_stack $table($state:$token,target)
                lappend value_stack $buflval
                set token ""
            }
            reduce {
                set rule $table($state:$token,target)
                set ll $rules($rule,l)
                if {[info exists rules($rule,e)]} {
                    set dc $rules($rule,e)
                } else {
                    set dc $rules($rule,dc)
                }
                set stackpointer [expr {[llength $state_stack]-$dc}]
                setupvalues $value_stack $stackpointer $dc
                set _ $1
                set yylval [lindex $value_stack end]
                switch -- $rule {
                    1 { ProcessSendCmdYesNo bin lock }
                    2 { ProcessSendCmdCurrent "get bin cursor" }
                    3 { ProcessSendCmdGet bin buffersize }
                    4 { ProcessSendCmdCurrent "get bin cols" }
                    5 { ProcessSendCmdGet bin factor }
                    6 { ProcessSendCmdGet bin depth }
                    7 { ProcessSendCmdCurrent "get bin filter" }
                    8 { ProcessSendCmdGet bin function }
                }
                unsetupvalues $dc
                # pop off tokens from the stack if normal rule
                if {![info exists rules($rule,e)]} {
                    incr stackpointer -1
                    set state_stack [lrange $state_stack 0 $stackpointer]
                    set value_stack [lrange $value_stack 0 $stackpointer]
                }
                # now do the goto transition
                lappend state_stack $table([lindex $state_stack end]:$ll,target)
                lappend value_stack $_
            }
            accept {
                set accepted 1
            }
            goto -
            default {
                puts stderr "Internal parser error: illegal command $table($state:$token)"
                return 2
            }
        }
    }
    return 0
}

######
# end autogenerated taccle functions
######

proc binsend::yyerror {msg} {
     variable yycnt
     variable yy_current_buffer
     variable index_

     ParserError $msg $yycnt $yy_current_buffer $index_
}
