package provide DS9 1.0

######
# Begin autogenerated taccle (version 1.3) routines.
# Although taccle itself is protected by the GNU Public License (GPL)
# all user-supplied functions are protected by their respective
# author's license.  See http://mini.net/tcl/taccle for other details.
######

namespace eval locksend {
    variable yylval {}
    variable table
    variable rules
    variable token {}
    variable yycnt 0
    variable yyerr 0
    variable save_state 0

    namespace export yylex
}

proc locksend::YYABORT {} {
    return -code return 1
}

proc locksend::YYACCEPT {} {
    return -code return 0
}

proc locksend::YYERROR {} {
    variable yyerr
    set yyerr 1
}

proc locksend::yyclearin {} {
    variable token
    variable yycnt
    set token {}
    incr yycnt -1
}

proc locksend::yyerror {s} {
    puts stderr $s
}

proc locksend::setupvalues {stack pointer numsyms} {
    upvar 1 1 y
    set y {}
    for {set i 1} {$i <= $numsyms} {incr i} {
        upvar 1 $i y
        set y [lindex $stack $pointer]
        incr pointer
    }
}

proc locksend::unsetupvalues {numsyms} {
    for {set i 1} {$i <= $numsyms} {incr i} {
        upvar 1 $i y
        unset y
    }
}

array set locksend::table {
  0:257 shift
  0:258 shift
  0:259 shift
  0:260 shift
  5:0,target 9
  0:266,target 10
  0:261 shift
  9:0 reduce
  0:262 shift
  11:0 reduce
  0:263 shift
  0:264 shift
  0:265 shift
  0:266 shift
  0:267 shift
  0:265,target 9
  0:268 shift
  0:269 goto
  6:0,target 3
  2:0 reduce
  6:0 reduce
  0:264,target 8
  7:0,target 2
  12:0 reduce
  10:0,target 8
  0:263,target 7
  3:0 reduce
  8:0,target 1
  1:0,target 12
  11:0,target 4
  0:262,target 6
  7:0 reduce
  13:0 accept
  0:261,target 5
  9:0,target 7
  2:0,target 6
  12:0,target 11
  0:259,target 3
  0:260,target 4
  0:269,target 13
  4:0 reduce
  3:0,target 5
  13:0,target 0
  8:0 reduce
  10:0 reduce
  0:258,target 2
  0:268,target 12
  4:0,target 10
  0:257,target 1
  1:0 reduce
  0:267,target 11
  5:0 reduce
}

array set locksend::rules {
  9,l 269
  11,l 269
  2,l 269
  6,l 269
  12,l 269
  3,l 269
  7,l 269
  0,l 270
  4,l 269
  8,l 269
  10,l 269
  1,l 269
  5,l 269
}

array set locksend::rules {
  5,dc 1
  0,dc 1
  12,dc 1
  8,dc 1
  3,dc 1
  10,dc 1
  6,dc 1
  1,dc 1
  9,dc 1
  4,dc 1
  11,dc 1
  7,dc 1
  2,dc 1
}

array set locksend::rules {
  7,line 30
  10,line 33
  4,line 27
  1,line 24
  9,line 32
  12,line 35
  6,line 29
  3,line 26
  8,line 31
  11,line 34
  5,line 28
  2,line 25
}

array set locksend::lr1_table {
  13,trans {}
  0 {{0 0 0} {1 0 0} {2 0 0} {3 0 0} {4 0 0} {5 0 0} {6 0 0} {7 0 0} {8 0 0} {9 0 0} {10 0 0} {11 0 0} {12 0 0}}
  1 {{12 0 1}}
  2 {{6 0 1}}
  3 {{5 0 1}}
  0,trans {{257 1} {258 2} {259 3} {260 4} {261 5} {262 6} {263 7} {264 8} {265 9} {266 10} {267 11} {268 12} {269 13}}
  4 {{10 0 1}}
  1,trans {}
  5 {{9 0 1}}
  2,trans {}
  6 {{3 0 1}}
  3,trans {}
  7 {{2 0 1}}
  4,trans {}
  8 {{1 0 1}}
  5,trans {}
  9 {{7 0 1}}
  10 {{8 0 1}}
  6,trans {}
  11 {{4 0 1}}
  7,trans {}
  12 {{11 0 1}}
  8,trans {}
  13 {{0 0 1}}
  10,trans {}
  9,trans {}
  11,trans {}
  12,trans {}
}

array set locksend::token_id_table {
  264,line 15
  270,t 1
  269,t 1
  265,title SCALE
  261,line 12
  257,t 0
  270,title {}
  269,title {}
  257,line 8
  262,t 0
  270,line 36
  269,line 23
  259,title BIN
  260,title BLOCK
  266,t 0
  error error
  264,title FRAME
  266,line 17
  error,line 22
  268,title SMOOTH
  258,t 0
  263,line 14
  error,title {}
  263,t 0
  259,line 10
  260,line 11
  258,title AXES
  267,t 0
  263,title CROSSHAIR
  268,line 19
  267,title SLICE
  257 3D_
  258 AXES_
  259,t 0
  259 BIN_
  260 BLOCK_
  260,t 0
  261 COLORBAR_
  265,line 16
  262 CROP_
  263 CROSSHAIR_
  257,title 3D
  264 FRAME_
  264,t 0
  265 SCALE_
  262,line 13
  266 SCALELIMITS_
  267 SLICE_
  0,t 0
  0 {$}
  262,title CROP
  268 SMOOTH_
  268,t 0
  270 start'
  269 locksend
  error,t 0
  258,line 9
  266,title SCALELIMITS
  261,t 0
  267,line 18
  265,t 0
  261,title COLORBAR
}

proc locksend::yyparse {} {
    variable yylval
    variable table
    variable rules
    variable token
    variable yycnt
    variable lr1_table
    variable token_id_table
    variable yyerr
    variable save_state

    set yycnt 0
    set state_stack {0}
    set value_stack {{}}
    set token ""
    set accepted 0
    set yyerr 0
    set save_state 0

    while {$accepted == 0} {
        set state [lindex $state_stack end]
        if {$token == ""} {
            set yylval ""
            set token [yylex]
            set buflval $yylval
	    if {$token>0} {
	        incr yycnt
            }
        }
        if {![info exists table($state:$token)] || $yyerr} {
	    if {!$yyerr} {
	        set save_state $state
	    }
            # pop off states until error token accepted
            while {[llength $state_stack] > 0 && \
                       ![info exists table($state:error)]} {
                set state_stack [lrange $state_stack 0 end-1]
                set value_stack [lrange $value_stack 0 \
                                       [expr {[llength $state_stack] - 1}]]
                set state [lindex $state_stack end]
            }
            if {[llength $state_stack] == 0} {
 
	        set rr { }
                if {[info exists lr1_table($save_state,trans)] && [llength $lr1_table($save_state,trans)] >= 1} {
                    foreach trans $lr1_table($save_state,trans) {
                        foreach {tok_id nextstate} $trans {
			    set ss $token_id_table($tok_id,title)
			    if {$ss != {}} {
			        append rr "$ss, "
                            }
                        }
                    }
                }
		set rr [string trimleft $rr { }]
		set rr [string trimright $rr {, }]
                yyerror "parse error, expecting: $rr"


                return 1
            }
            lappend state_stack [set state $table($state:error,target)]
            lappend value_stack {}
            # consume tokens until it finds an acceptable one
            while {![info exists table($state:$token)]} {
                if {$token == 0} {
                    yyerror "end of file while recovering from error"
                    return 1
                }
                set yylval {}
                set token [yylex]
                set buflval $yylval
            }
            continue
        }
        switch -- $table($state:$token) {
            shift {
                lappend state_stack $table($state:$token,target)
                lappend value_stack $buflval
                set token ""
            }
            reduce {
                set rule $table($state:$token,target)
                set ll $rules($rule,l)
                if {[info exists rules($rule,e)]} {
                    set dc $rules($rule,e)
                } else {
                    set dc $rules($rule,dc)
                }
                set stackpointer [expr {[llength $state_stack]-$dc}]
                setupvalues $value_stack $stackpointer $dc
                set _ $1
                set yylval [lindex $value_stack end]
                switch -- $rule {
                    1 { ProcessSendCmdGet panzoom lock }
                    2 { ProcessSendCmdGet crosshair lock }
                    3 { ProcessSendCmdGet crop lock }
                    4 { ProcessSendCmdGet cube lock }
                    5 { ProcessSendCmdYesNo bin lock }
                    6 { ProcessSendCmdYesNo cube lock,axes }
                    7 { ProcessSendCmdYesNo scale lock }
                    8 { ProcessSendCmdYesNo scale lock,limits }
                    9 { ProcessSendCmdYesNo colorbar lock }
                    10 { ProcessSendCmdYesNo block lock }
                    11 { ProcessSendCmdYesNo smooth lock }
                    12 { ProcessSendCmdYesNo threed lock }
                }
                unsetupvalues $dc
                # pop off tokens from the stack if normal rule
                if {![info exists rules($rule,e)]} {
                    incr stackpointer -1
                    set state_stack [lrange $state_stack 0 $stackpointer]
                    set value_stack [lrange $value_stack 0 $stackpointer]
                }
                # now do the goto transition
                lappend state_stack $table([lindex $state_stack end]:$ll,target)
                lappend value_stack $_
            }
            accept {
                set accepted 1
            }
            goto -
            default {
                puts stderr "Internal parser error: illegal command $table($state:$token)"
                return 2
            }
        }
    }
    return 0
}

######
# end autogenerated taccle functions
######

proc locksend::yyerror {msg} {
     variable yycnt
     variable yy_current_buffer
     variable index_

     ParserError $msg $yycnt $yy_current_buffer $index_
}
