package provide DS9 1.0

######
# Begin autogenerated taccle (version 1.3) routines.
# Although taccle itself is protected by the GNU Public License (GPL)
# all user-supplied functions are protected by their respective
# author's license.  See http://mini.net/tcl/taccle for other details.
######

namespace eval rotate {
    variable yylval {}
    variable table
    variable rules
    variable token {}
    variable yycnt 0
    variable yyerr 0
    variable save_state 0

    namespace export yylex
}

proc rotate::YYABORT {} {
    return -code return 1
}

proc rotate::YYACCEPT {} {
    return -code return 0
}

proc rotate::YYERROR {} {
    variable yyerr
    set yyerr 1
}

proc rotate::yyclearin {} {
    variable token
    variable yycnt
    set token {}
    incr yycnt -1
}

proc rotate::yyerror {s} {
    puts stderr $s
}

proc rotate::setupvalues {stack pointer numsyms} {
    upvar 1 1 y
    set y {}
    for {set i 1} {$i <= $numsyms} {incr i} {
        upvar 1 $i y
        set y [lindex $stack $pointer]
        incr pointer
    }
}

proc rotate::unsetupvalues {numsyms} {
    for {set i 1} {$i <= $numsyms} {incr i} {
        upvar 1 $i y
        unset y
    }
}

array set rotate::table {
  0:257 shift
  0:258 shift
  0:260 shift
  9:0 reduce
  0:261 shift
  0:266,target 8
  6:259,target 6
  11:0 reduce
  0:262 shift
  2:259 reduce
  0:263 goto
  0:264 goto
  1:259,target 1
  4:259 reduce
  0:266 goto
  6:259 reduce
  8:259 reduce
  6:0,target 6
  2:0 reduce
  9:259,target 7
  8:265 goto
  6:0 reduce
  0:264,target 7
  4:259,target 8
  8:265,target 10
  7:0,target 0
  5:263,target 9
  0:263,target 6
  10:259 shift
  3:0 reduce
  8:0,target 3
  1:0,target 1
  11:0,target 5
  0:262,target 5
  2:259,target 2
  7:0 accept
  1:259 reduce
  3:259 reduce
  5:257 shift
  9:0,target 7
  0:261,target 4
  5:258 shift
  2:0,target 2
  5:263 goto
  9:259 reduce
  0:260,target 3
  4:0 reduce
  3:0,target 9
  5:258,target 2
  8:0 reduce
  0:258,target 2
  8:259,target 4
  3:259,target 9
  5:257,target 1
  4:0,target 8
  0:257,target 1
  1:0 reduce
  10:259,target 11
}

array set rotate::rules {
  9,l 266
  2,l 263
  6,l 266
  3,l 264
  7,l 266
  0,l 267
  4,l 265
  8,l 266
  1,l 263
  5,l 264
}

array set rotate::rules {
  5,dc 3
  0,dc 1
  8,dc 1
  3,dc 1
  6,dc 1
  1,dc 1
  9,dc 1
  4,dc 0
  7,dc 2
  2,dc 1
}

array set rotate::rules {
  7,line 33
  4,line 28
  1,line 24
  9,line 35
  6,line 32
  3,line 28
  4,e 1
  8,line 34
  5,line 29
  2,line 25
}

array set rotate::lr1_table {
  0 {{0 0 0} {3 0 0} {5 0 0} {6 {0 259} 0} {7 {0 259} 0} {8 {0 259} 0} {9 {0 259} 0} {1 {0 259} 0} {2 {0 259} 0}}
  1 {{1 {0 259} 1}}
  2 {{2 {0 259} 1}}
  3 {{9 {0 259} 1}}
  4 {{8 {0 259} 1}}
  0,trans {{257 1} {258 2} {260 3} {261 4} {262 5} {263 6} {264 7} {266 8}}
  5 {{7 {0 259} 1} {1 {0 259} 0} {2 {0 259} 0}}
  1,trans {}
  6 {{6 {0 259} 1}}
  2,trans {}
  3,trans {}
  7 {{0 0 1}}
  4,trans {}
  8 {{3 0 1} {5 0 1} {4 259 0}}
  10 {{5 0 2}}
  5,trans {{257 1} {258 2} {263 9}}
  9 {{7 {0 259} 2}}
  11 {{5 0 3}}
  6,trans {}
  7,trans {}
  8,trans {{265 10}}
  10,trans {{259 11}}
  9,trans {}
  11,trans {}
}

array set rotate::token_id_table {
  264,line 27
  265,title {}
  261,line 15
  257,t 0
  257,line 7
  262,t 0
  259,title string
  260,title CLOSE
  266,t 1
  error error
  264,title {}
  266,line 31
  error,line 22
  258,t 0
  263,line 23
  error,title {}
  263,t 1
  259,line 10
  260,line 14
  258,title float
  267,t 1
  263,title {}
  267,title {}
  257 INT_
  258 REAL_
  259,t 0
  259 STRING_
  260 CLOSE_
  260,t 0
  261 OPEN_
  265,line 28
  262 TO_
  263 numeric
  257,title integer
  264 command
  264,t 1
  265 @PSEUDO1
  262,line 16
  266 rotate
  267 start'
  262,title TO
  0 {$}
  0,t 0
  error,t 0
  258,line 8
  266,title {}
  261,t 0
  267,line 36
  265,t 1
  261,title OPEN
}

proc rotate::yyparse {} {
    variable yylval
    variable table
    variable rules
    variable token
    variable yycnt
    variable lr1_table
    variable token_id_table
    variable yyerr
    variable save_state

    set yycnt 0
    set state_stack {0}
    set value_stack {{}}
    set token ""
    set accepted 0
    set yyerr 0
    set save_state 0

    while {$accepted == 0} {
        set state [lindex $state_stack end]
        if {$token == ""} {
            set yylval ""
            set token [yylex]
            set buflval $yylval
	    if {$token>0} {
	        incr yycnt
            }
        }
        if {![info exists table($state:$token)] || $yyerr} {
	    if {!$yyerr} {
	        set save_state $state
	    }
            # pop off states until error token accepted
            while {[llength $state_stack] > 0 && \
                       ![info exists table($state:error)]} {
                set state_stack [lrange $state_stack 0 end-1]
                set value_stack [lrange $value_stack 0 \
                                       [expr {[llength $state_stack] - 1}]]
                set state [lindex $state_stack end]
            }
            if {[llength $state_stack] == 0} {
 
	        set rr { }
                if {[info exists lr1_table($save_state,trans)] && [llength $lr1_table($save_state,trans)] >= 1} {
                    foreach trans $lr1_table($save_state,trans) {
                        foreach {tok_id nextstate} $trans {
			    set ss $token_id_table($tok_id,title)
			    if {$ss != {}} {
			        append rr "$ss, "
                            }
                        }
                    }
                }
		set rr [string trimleft $rr { }]
		set rr [string trimright $rr {, }]
                yyerror "parse error, expecting: $rr"


                return 1
            }
            lappend state_stack [set state $table($state:error,target)]
            lappend value_stack {}
            # consume tokens until it finds an acceptable one
            while {![info exists table($state:$token)]} {
                if {$token == 0} {
                    yyerror "end of file while recovering from error"
                    return 1
                }
                set yylval {}
                set token [yylex]
                set buflval $yylval
            }
            continue
        }
        switch -- $table($state:$token) {
            shift {
                lappend state_stack $table($state:$token,target)
                lappend value_stack $buflval
                set token ""
            }
            reduce {
                set rule $table($state:$token,target)
                set ll $rules($rule,l)
                if {[info exists rules($rule,e)]} {
                    set dc $rules($rule,e)
                } else {
                    set dc $rules($rule,dc)
                }
                set stackpointer [expr {[llength $state_stack]-$dc}]
                setupvalues $value_stack $stackpointer $dc
                set _ $1
                set yylval [lindex $value_stack end]
                switch -- $rule {
                    1 { set _ $1 }
                    2 { set _ $1 }
                    4 { global ds9; if {!$ds9(init)} {YYERROR} else {yyclearin; YYACCEPT} }
                    6 { Rotate $1 }
                    7 { ProcessCmdSet current rotate $2 ChangeRotate }
                    8 { PanZoomDialog }
                    9 { PanZoomDestroyDialog }
                }
                unsetupvalues $dc
                # pop off tokens from the stack if normal rule
                if {![info exists rules($rule,e)]} {
                    incr stackpointer -1
                    set state_stack [lrange $state_stack 0 $stackpointer]
                    set value_stack [lrange $value_stack 0 $stackpointer]
                }
                # now do the goto transition
                lappend state_stack $table([lindex $state_stack end]:$ll,target)
                lappend value_stack $_
            }
            accept {
                set accepted 1
            }
            goto -
            default {
                puts stderr "Internal parser error: illegal command $table($state:$token)"
                return 2
            }
        }
    }
    return 0
}

######
# end autogenerated taccle functions
######

proc rotate::yyerror {msg} {
     variable yycnt
     variable yy_current_buffer
     variable index_

     ParserError $msg $yycnt $yy_current_buffer $index_
}
