package provide DS9 1.0

######
# Begin autogenerated taccle (version 1.3) routines.
# Although taccle itself is protected by the GNU Public License (GPL)
# all user-supplied functions are protected by their respective
# author's license.  See http://mini.net/tcl/taccle for other details.
######

namespace eval threads {
    variable yylval {}
    variable table
    variable rules
    variable token {}
    variable yycnt 0
    variable yyerr 0
    variable save_state 0

    namespace export yylex
}

proc threads::YYABORT {} {
    return -code return 1
}

proc threads::YYACCEPT {} {
    return -code return 0
}

proc threads::YYERROR {} {
    variable yyerr
    set yyerr 1
}

proc threads::yyclearin {} {
    variable token
    variable yycnt
    set token {}
    incr yycnt -1
}

proc threads::yyerror {s} {
    puts stderr $s
}

proc threads::setupvalues {stack pointer numsyms} {
    upvar 1 1 y
    set y {}
    for {set i 1} {$i <= $numsyms} {incr i} {
        upvar 1 $i y
        set y [lindex $stack $pointer]
        incr pointer
    }
}

proc threads::unsetupvalues {numsyms} {
    for {set i 1} {$i <= $numsyms} {incr i} {
        upvar 1 $i y
        unset y
    }
}

array set threads::table {
  3:0,target 1
  0:257 shift
  5:0,target 3
  0:259 goto
  1:258 reduce
  0:261 goto
  3:258 reduce
  4:258 shift
  3:260 goto
  0:261,target 3
  2:0,target 0
  4:258,target 5
  3:260,target 4
  0:257,target 1
  1:0 reduce
  2:0 accept
  3:0 reduce
  0:259,target 2
  1:258,target 4
  1:0,target 4
  5:0 reduce
  3:258,target 2
}

array set threads::rules {
  0,l 262
  1,l 259
  2,l 260
  3,l 259
  4,l 261
}

array set threads::rules {
  0,dc 1
  2,dc 0
  4,dc 1
  1,dc 1
  3,dc 3
}

array set threads::rules {
  2,e 1
  2,line 16
  4,line 20
  1,line 16
  3,line 17
}

array set threads::lr1_table {
  0 {{0 0 0} {1 0 0} {3 0 0} {4 {0 258} 0}}
  1 {{4 {0 258} 1}}
  2 {{0 0 1}}
  3 {{1 0 1} {3 0 1} {2 258 0}}
  0,trans {{257 1} {259 2} {261 3}}
  4 {{3 0 2}}
  1,trans {}
  5 {{3 0 3}}
  2,trans {}
  3,trans {{260 4}}
  4,trans {{258 5}}
  5,trans {}
}

array set threads::token_id_table {
  262,title {}
  0 {$}
  0,t 0
  error,t 0
  error error
  258,line 9
  261,line 19
  error,line 14
  257 INT_
  257,t 0
  258 STRING_
  258,t 0
  260,t 1
  260 @PSEUDO1
  259,t 1
  259 command
  error,title {}
  261,t 1
  261 threads
  262,t 1
  262 start'
  257,line 7
  260,line 16
  259,line 15
  257,title integer
  258,title string
  262,line 21
  260,title {}
  259,title {}
  261,title {}
}

proc threads::yyparse {} {
    variable yylval
    variable table
    variable rules
    variable token
    variable yycnt
    variable lr1_table
    variable token_id_table
    variable yyerr
    variable save_state

    set yycnt 0
    set state_stack {0}
    set value_stack {{}}
    set token ""
    set accepted 0
    set yyerr 0
    set save_state 0

    while {$accepted == 0} {
        set state [lindex $state_stack end]
        if {$token == ""} {
            set yylval ""
            set token [yylex]
            set buflval $yylval
	    if {$token>0} {
	        incr yycnt
            }
        }
        if {![info exists table($state:$token)] || $yyerr} {
	    if {!$yyerr} {
	        set save_state $state
	    }
            # pop off states until error token accepted
            while {[llength $state_stack] > 0 && \
                       ![info exists table($state:error)]} {
                set state_stack [lrange $state_stack 0 end-1]
                set value_stack [lrange $value_stack 0 \
                                       [expr {[llength $state_stack] - 1}]]
                set state [lindex $state_stack end]
            }
            if {[llength $state_stack] == 0} {
 
	        set rr { }
                if {[info exists lr1_table($save_state,trans)] && [llength $lr1_table($save_state,trans)] >= 1} {
                    foreach trans $lr1_table($save_state,trans) {
                        foreach {tok_id nextstate} $trans {
			    set ss $token_id_table($tok_id,title)
			    if {$ss != {}} {
			        append rr "$ss, "
                            }
                        }
                    }
                }
		set rr [string trimleft $rr { }]
		set rr [string trimright $rr {, }]
                yyerror "parse error, expecting: $rr"


                return 1
            }
            lappend state_stack [set state $table($state:error,target)]
            lappend value_stack {}
            # consume tokens until it finds an acceptable one
            while {![info exists table($state:$token)]} {
                if {$token == 0} {
                    yyerror "end of file while recovering from error"
                    return 1
                }
                set yylval {}
                set token [yylex]
                set buflval $yylval
            }
            continue
        }
        switch -- $table($state:$token) {
            shift {
                lappend state_stack $table($state:$token,target)
                lappend value_stack $buflval
                set token ""
            }
            reduce {
                set rule $table($state:$token,target)
                set ll $rules($rule,l)
                if {[info exists rules($rule,e)]} {
                    set dc $rules($rule,e)
                } else {
                    set dc $rules($rule,dc)
                }
                set stackpointer [expr {[llength $state_stack]-$dc}]
                setupvalues $value_stack $stackpointer $dc
                set _ $1
                set yylval [lindex $value_stack end]
                switch -- $rule {
                    2 { global ds9; if {!$ds9(init)} {YYERROR} else {yyclearin; YYACCEPT} }
                    4 { ProcessCmdSet ds9 threads $1 ChangeThreads }
                }
                unsetupvalues $dc
                # pop off tokens from the stack if normal rule
                if {![info exists rules($rule,e)]} {
                    incr stackpointer -1
                    set state_stack [lrange $state_stack 0 $stackpointer]
                    set value_stack [lrange $value_stack 0 $stackpointer]
                }
                # now do the goto transition
                lappend state_stack $table([lindex $state_stack end]:$ll,target)
                lappend value_stack $_
            }
            accept {
                set accepted 1
            }
            goto -
            default {
                puts stderr "Internal parser error: illegal command $table($state:$token)"
                return 2
            }
        }
    }
    return 0
}

######
# end autogenerated taccle functions
######

proc threads::yyerror {msg} {
     variable yycnt
     variable yy_current_buffer
     variable index_

     ParserError $msg $yycnt $yy_current_buffer $index_
}
